Pyramid Chart in JavaScript

Using ApexCharts with JavaScript

This Pyramid Chart example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: '',
      data: [200, 330, 548, 740, 880, 990, 1100, 1380],
    },
  ],
  chart: {
    type: 'pyramid',
    height: 350,
    dropShadow: {
      enabled: true,
    },
  },
  plotOptions: {
    bar: {
      borderRadius: 0,
      distributed: true,
    },
  },
  colors: [
    '#809bce',
    '#95b8d1',
    '#b8e0d4',
    '#d6eadf',
    '#eac4d5',
    '#d1625c',
    '#e89c81',
    '#ffd6a5',
  ],
  dataLabels: {
    enabled: true,
    formatter: function (val, opt) {
      // hide labels on tiers too small to fit them; the tooltip still names these
      if (val < 400) return ''
      return opt.w.globals.labels[opt.dataPointIndex]
    },
    dropShadow: {
      enabled: true,
    },
  },
  title: {
    text: 'Food Pyramid',
    align: 'middle',
  },
  xaxis: {
    categories: [
      'Sweets',
      'Processed Foods',
      'Healthy Fats',
      'Meat',
      'Beans & Legumes',
      'Dairy',
      'Fruits & Vegetables',
      'Grains',
    ],
  },
  legend: {
    show: false,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Pyramid Chart in React

Using ApexCharts with React

This Pyramid Chart example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: '',
        data: [200, 330, 548, 740, 880, 990, 1100, 1380],
      },
    ],
    options: {
      chart: {
        type: 'pyramid',
        height: 350,
        dropShadow: {
          enabled: true,
        },
      },
      plotOptions: {
        bar: {
          borderRadius: 0,
          distributed: true,
        },
      },
      colors: [
        '#809bce',
        '#95b8d1',
        '#b8e0d4',
        '#d6eadf',
        '#eac4d5',
        '#d1625c',
        '#e89c81',
        '#ffd6a5',
      ],
      dataLabels: {
        enabled: true,
        formatter: function (val, opt) {
          // hide labels on tiers too small to fit them; the tooltip still names these
          if (val < 400) return ''
          return opt.w.globals.labels[opt.dataPointIndex]
        },
        dropShadow: {
          enabled: true,
        },
      },
      title: {
        text: 'Food Pyramid',
        align: 'middle',
      },
      xaxis: {
        categories: [
          'Sweets',
          'Processed Foods',
          'Healthy Fats',
          'Meat',
          'Beans & Legumes',
          'Dairy',
          'Fruits & Vegetables',
          'Grains',
        ],
      },
      legend: {
        show: false,
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="pyramid"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Pyramid Chart in Vue

Using ApexCharts with Vue

This Pyramid Chart example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="pyramid"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: '',
          data: [200, 330, 548, 740, 880, 990, 1100, 1380],
        },
      ],
      chartOptions: {
        chart: {
          type: 'pyramid',
          height: 350,
          dropShadow: {
            enabled: true,
          },
        },
        plotOptions: {
          bar: {
            borderRadius: 0,
            distributed: true,
          },
        },
        colors: [
          '#809bce',
          '#95b8d1',
          '#b8e0d4',
          '#d6eadf',
          '#eac4d5',
          '#d1625c',
          '#e89c81',
          '#ffd6a5',
        ],
        dataLabels: {
          enabled: true,
          formatter: function (val, opt) {
            // hide labels on tiers too small to fit them; the tooltip still names these
            if (val < 400) return ''
            return opt.w.globals.labels[opt.dataPointIndex]
          },
          dropShadow: {
            enabled: true,
          },
        },
        title: {
          text: 'Food Pyramid',
          align: 'middle',
        },
        xaxis: {
          categories: [
            'Sweets',
            'Processed Foods',
            'Healthy Fats',
            'Meat',
            'Beans & Legumes',
            'Dairy',
            'Fruits & Vegetables',
            'Grains',
          ],
        },
        legend: {
          show: false,
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Pyramid Chart in Angular

Using ApexCharts with Angular

This Pyramid Chart example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: '',
              data: [200, 330, 548, 740, 880, 990, 1100, 1380],
            },
          ],
          chart: {
            type: 'pyramid',
            height: 350,
            dropShadow: {
              enabled: true,
            },
          },
          plotOptions: {
            bar: {
              borderRadius: 0,
              distributed: true,
            },
          },
          colors: [
            '#809bce',
            '#95b8d1',
            '#b8e0d4',
            '#d6eadf',
            '#eac4d5',
            '#d1625c',
            '#e89c81',
            '#ffd6a5',
          ],
          dataLabels: {
            enabled: true,
            formatter: (val, opt) => {
              // hide labels on tiers too small to fit them; the tooltip still names these
              if (val < 400) return ''
              return opt.w.globals.labels[opt.dataPointIndex]
            },
            dropShadow: {
              enabled: true,
            },
          },
          title: {
            text: 'Food Pyramid',
            align: 'middle',
          },
          xaxis: {
            categories: [
              'Sweets',
              'Processed Foods',
              'Healthy Fats',
              'Meat',
              'Beans & Legumes',
              'Dairy',
              'Fruits & Vegetables',
              'Grains',
            ],
          },
          legend: {
            show: false,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}